"use strict";
var ais_payload_data_converter_1 = require("../ais-payload-data-converter");
var AisMessageBase = (function () {
    function AisMessageBase(_type, payloadBits) {
        this._type = _type;
        this.payloadBits = payloadBits;
    }
    Object.defineProperty(AisMessageBase.prototype, "type", {
        get: function () {
            return this._type;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AisMessageBase.prototype, "repeat", {
        get: function () {
            return this.toInt(6, 2);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AisMessageBase.prototype, "mmsi", {
        get: function () {
            return this.toInt(8, 30);
        },
        enumerable: true,
        configurable: true
    });
    AisMessageBase.prototype.toInt = function (index, length) {
        return ais_payload_data_converter_1.AisPayloadDataConverter.toInt(this.payloadBits, index, length);
    };
    AisMessageBase.prototype.toBoolean = function (index) {
        return ais_payload_data_converter_1.AisPayloadDataConverter.toBoolean(this.payloadBits, index);
    };
    AisMessageBase.prototype.toSixBitString = function (index, charSize) {
        return ais_payload_data_converter_1.AisPayloadDataConverter.toSixBitString(this.payloadBits, index, charSize);
    };
    AisMessageBase.prototype.getLongitudeDeg = function (raw_longitude) {
        if (raw_longitude >= 0x8000000) {
            raw_longitude = -1 * (0x10000000 - raw_longitude);
        }
        return raw_longitude / 600000.0;
    };
    AisMessageBase.prototype.getLatitudeDeg = function (raw_latitude) {
        if (raw_latitude >= 0x4000000) {
            raw_latitude = -1 * (0x8000000 - raw_latitude);
        }
        return raw_latitude / 600000.0;
    };
    return AisMessageBase;
}());
exports.AisMessageBase = AisMessageBase;
//# sourceMappingURL=C:/Users/aroll/Projects/AIS/trunk/ts/ais-js/src/ais/message/ais-message-base.js.map