"use strict";
var aivdm_nmea_1 = require("./aivdm-nmea");
var AivdmSentence = (function () {
    function AivdmSentence(nmea) {
        this.aivdms = [];
        if (!(nmea instanceof aivdm_nmea_1.AivdmNmea)) {
            throw new Error("parameter is null.");
        }
        this.baseNmea = nmea;
        this.aivdms.push(nmea);
    }
    AivdmSentence.prototype.isComplete = function () {
        return this.aivdms.length === this.baseNmea.countOfFragments;
    };
    AivdmSentence.prototype.isAddable = function (aivdm) {
        return !this.isComplete() &&
            this.baseNmea.packetId === aivdm.packetId &&
            this.aivdms.filter(function (element, index, array) {
                return aivdm.fragmentNumber === element.fragmentNumber;
            }).length === 0 &&
            this.baseNmea.sequentialId === aivdm.sequentialId &&
            this.baseNmea.radioChannel === aivdm.radioChannel;
    };
    AivdmSentence.prototype.add = function (aivdm) {
        if (!this.isAddable(aivdm)) {
            throw new Error("Cannot add aivdm. The aivdm is different from the others.");
        }
        this.aivdms.push(aivdm);
    };
    Object.defineProperty(AivdmSentence.prototype, "payload", {
        get: function () {
            if (!this.isComplete()) {
                throw new Error("Cannot output payload. Sentence is not complete.");
            }
            var concat = "";
            this.aivdms.sort(function (a, b) {
                return a.fragmentNumber > b.fragmentNumber ? 1 : -1;
            }).forEach(function (element, index, array) {
                concat += element.payload;
            });
            return concat;
        },
        enumerable: true,
        configurable: true
    });
    return AivdmSentence;
}());
exports.AivdmSentence = AivdmSentence;
//# sourceMappingURL=C:/Users/aroll/Projects/AIS/trunk/ts/ais-js/src/aivdm/aivdm-sentence.js.map