"use strict";
var Nmea = (function () {
    function Nmea(_line) {
        this._line = _line;
        if (!Nmea.isValid(_line)) {
            throw new Error("line is not valid(" + _line + ").");
        }
    }
    Nmea.isValid = function (source) {
        var matched = source.match(Nmea.NMEA_REGEX);
        var data = matched[1];
        var checksum = parseInt(matched[2], 16);
        var calcedChecksum = 0;
        for (var _i = 0, data_1 = data; _i < data_1.length; _i++) {
            var i = data_1[_i];
            calcedChecksum ^= i.charCodeAt(0);
        }
        return checksum === calcedChecksum;
    };
    Object.defineProperty(Nmea.prototype, "line", {
        get: function () {
            return this._line;
        },
        enumerable: true,
        configurable: true
    });
    return Nmea;
}());
Nmea.NMEA_REGEX = /^[!$]([^\*]+)\*([0-9a-fA-F]+)\r?$/;
exports.Nmea = Nmea;
//# sourceMappingURL=C:/Users/aroll/Projects/AIS/trunk/ts/ais-js/src/nmea/nmea.js.map