"use strict";
var AisPayloadDataConverter = (function () {
    function AisPayloadDataConverter() {
    }
    AisPayloadDataConverter.toInt = function (payload, index, length) {
        var result = 0;
        var shift = length - 1;
        for (var i = length - 1; i >= 0; i--) {
            result |= (payload[index + i]) << (shift - i);
        }
        return result;
    };
    AisPayloadDataConverter.toBoolean = function (payload, index) {
        return payload[index] === 1;
    };
    AisPayloadDataConverter.toSixBitString = function (payload, index, charSize) {
        var result = "";
        for (var i = 0; i < charSize; i++) {
            result += this.toSixBitASCII(payload, index + i * 6);
        }
        return result;
    };
    AisPayloadDataConverter.toSixBitASCII = function (payload, index) {
        var result = 0;
        var value = this.toInt(payload, index, 6);
        if (value > 0x3F) {
            throw new Error("Value is out of range(" + value + ").");
        }
        if (value < 0x20) {
            result = value + 0x40;
        }
        else {
            result = value;
        }
        return String.fromCharCode(result);
    };
    return AisPayloadDataConverter;
}());
exports.AisPayloadDataConverter = AisPayloadDataConverter;
//# sourceMappingURL=C:/Users/aroll/Projects/AIS/trunk/ts/ais-js/src/ais/ais-payload-data-converter.js.map