"use strict";
var aivdm_payload_1 = require("./aivdm-payload");
var AivdmPayloadDecoder = (function () {
    function AivdmPayloadDecoder() {
    }
    AivdmPayloadDecoder.decodeString2Ascii = function (sentence) {
        return sentence.split(aivdm_payload_1.AivdmPayload.SEPARATE_CAHR).map(function (element) {
            return element.charCodeAt(0);
        });
    };
    AivdmPayloadDecoder.decodeString2Decimal = function (sentence) {
        return sentence.split(aivdm_payload_1.AivdmPayload.SEPARATE_CAHR).map(function (element) {
            return AivdmPayloadDecoder.decodeAscii2Decimal(element.charCodeAt(0));
        });
    };
    AivdmPayloadDecoder.decodeString2Bits = function (sentence) {
        var decimalArray = AivdmPayloadDecoder.decodeString2Decimal(sentence);
        var resultArray = [];
        var bitArray;
        for (var _i = 0, decimalArray_1 = decimalArray; _i < decimalArray_1.length; _i++) {
            var decimal = decimalArray_1[_i];
            bitArray = AivdmPayloadDecoder.decodeDecimal2Bits(decimal);
            Array.prototype.push.apply(resultArray, bitArray);
        }
        return resultArray;
    };
    AivdmPayloadDecoder.decodeAscii2Decimal = function (ascii) {
        if (!aivdm_payload_1.AivdmPayload.isValidAscii(ascii)) {
            throw new Error("Out of range.");
        }
        return (ascii < 0x60) ? (ascii - 0x30) & 0x3F : (ascii - 0x38) & 0x3F;
    };
    AivdmPayloadDecoder.decodeDecimal2Bits = function (decimal) {
        var result = [];
        for (var i = aivdm_payload_1.AivdmPayload.BIT_NUM - 1; i >= 0; i--) {
            result.push((decimal >> i) % 2);
        }
        return result;
    };
    return AivdmPayloadDecoder;
}());
exports.AivdmPayloadDecoder = AivdmPayloadDecoder;
//# sourceMappingURL=C:/Users/aroll/Projects/AIS/trunk/ts/ais-js/src/aivdm/aivdm-payload-decoder.js.map